page 62,132
.286c				;ermgliche v30-Befehle
;----------------------------------------------------------------;
TITLE RAMDISK
;
;
;Versionsnummer          1.50
;
;Beispielprogramm fr die Benutzung der SuperCharger-TOOLBOX
;
;
;
;----------------------------------------------------------------;
;EQUATES:
terminate	equ	0	;Programm wird beendet, Scheduler luft
killtb		equ	1	;Toolbox wird verlassen (idle-loop)
receivedata	equ	4	;Datenblock cx Bytes wird nach es:di geladen
senddat		equ	5	;Datenblock cx Bytes wird von ds:si gesendet
getbyte		equ	9	;Empfngt ein Byte nach al
sendbyte		equ	10	;Sendet Inhalt von al an ATARI
;	(Alle nicht benutzen Nummern intern oder fr Erweiterungen 
;	reserviert)
;----------------------------------------------------------------;
CODE SEGMENT para public 'code'
ASSUME CS:CODE
org	0

init:	cli				;initialisiere Stack (der Form halber, 
		mov	ax, cs		;Toolbox stellt ca 0f0h Worte zur 
		mov	ss, ax		;Verfgung)
		mov	sp, offset stacktop
main:	mov	ah, getbyte	;warte auf Auftragsnummer
		int	60h			;kommt zurck, wenn Atari sich meldet
		xor	ah, ah		;
		shl	al, 1		;Index fr Funktionsaufruf
		mov	si, ax		;bereit fr indizierten Funktionsaufruf
		call	word ptr cs:[auftragstab][si]
		jmp	main			;und ewig singen die...

;----------------------------------------
reset	label near		;lscht Speicher ab 0000:8000 mit 00.
		mov	bx, 1000h		;startsegment ist 1000h
		xor	ax, ax		;Speicherwert 0
		mov	di, ax		;initialisiere auf Offset 0
r00:		mov	es, bx		;zu beschreibendes Segment
		mov	cx, 8000h		;setze Counter auf 64k
		rep	stosw		;schreibt Nullen in Speicher
		add	bx, 1000h		;nchstes Segment
		jnz	r00			;Schleife fr alle Segmente
		mov	es, bx		;jetzt Segment 0, ab Offset 8000h
		mov	cx, 4000h		;32k
		mov	di, 8000h		;Offset
		rep	stosw		;das war's
		retn
;----------------------------------------
ramsize	label near		;wir machens uns einfach....
		push	0c000h		;Testsegment
		pop	ds			;nach ds
		xor	si, si		;Offset 0
		mov	bx, word ptr ds:[si] 	;sichere alten Wert
		mov	word ptr ds:[si], 1234h	;Testpattern
		xor	al, al		;Defaultantwort 1M
		cmp	word ptr ds:[si], 1234h	;steht's drin?
		je	einmeg		;ja...
		mov	al, 1		;Antwort fr ATARI (512k)
einmeg:	mov	byte ptr cs:[megaflag], al
		mov	ah, sendbyte	;Toolbox Funktionsnummer
		int	60h			;sendet Wert in al
		retn				;

;----------------------------------------
read		label near		;aus Ramdisk wird gelesen
		call	getaddress	;liefert Segmentadresse in bx
		mov	ds, bx		;initialisiere Toolboxaufruf
		xor	si, si		;Startoffset immer 0
		mov	cx, 512		;immer ein Sektor
		mov	ah, senddat	;Toolbox Funktions# sende Datenblock
		int	60h			;Toolbox Aufruf
		retn
;----------------------------------------
write	label near		;in Ramdisk wird geschrieben

		call	getaddress	;liefert Segmentadresse in bx
		mov	es, bx		;initialisiere Toolboxaufruf
		xor	di, di		;Startoffset immer 0
		mov	cx, 512		;immer ein Sektor
		mov	ah, receivedata	;Funktions# empf. Datenblock
		int	60h				;Toolbox Aufruf
		retn
;----------------------------------------
;getaddress:		liefert in bx Adresse des angesprochenen Sektors
;
;Zur Erklrung:	Die Ramdiskdaten belegen bei 1M SuperChargern den
;				Speicherbereich von 0000:8000 bis f000:ffff.
;				Bei 0,5M SuperChargern steht folgender RAM zur
;				Verfgung: 0000:8000 bis 6000:7fff, b000:8000 bis
;				b000:ffff sowie f000:0000 bis f000:ffff.
;				Zustzlich ist bei beiden Versionen der Bereich 
;				von 0000:0000 bis 0000:2fff fr die Toolbox sowie
;				Interruptvektortabelle belegt. Der fr Toolbox-
;				programme nutzbare Speicher beginnt bei 0000:3000
;				Hierhin haben wir auch das eigentlich Ramdisk-
;				Programm gelegt.
;
;	entry:	-
;	exit:	Segment fr angesprochenen Sektor in bx
;			ax ungesichert
;----------------------------------------
getaddress	label near

		mov	ah, getbyte	;hole Sektornummer lsb
		int	60h			;warte auf ATARI
		mov	bl, al		;Toolbox-call
		mov	ah, getbyte	;hole Sektornummer msb
		int	60h			;Toolbox-call
		mov	bh, al		;in bx jetzt Sektornummer
		shl	bx, 5		;*32 ergibt Segment fr Sektor
		add	bh, 8h		;addiere reservierten Speicherbereich
		cmp	byte ptr cs:[megaflag], 0 ;Ausnahmeregelungen ntig?
		jnz	checkexp		;512k-Charger, teste auf Speicherlcken
		retn
checkexp:	cmp	bh, 68h		;erste Lcke ab 6800:0
		jae	check1		;weitere Tests ntig
		retn				;unterer Bereich problemlos
check1:	add	bh, 50h		;weiter bei b800h
		cmp	bh, 0c0h		;zweite Lcke ?
		jae	check2		;
		retn				;Bereich ab b800 unter c000
check2:	or	bh, 0f0h		;es bleibt nur noch fxxx
		retn
		


;----------------------------------------
megaflag		db	0			;wenn 0, 1M RAM, wenn 1:0,5M
even
;----------------------------------------
auftragstab	dw	reset		;Speicher lschen
			dw	ramsize		;ob SC 0,5 oder 1M RAM hat
			dw	read			;lese aus Ramdisk
			dw	write		;schreibt in Ramdisk
;----------------------------------------
stapel		dw	1feh	dup	(?)	;
stacktop		dw	?
;----------------------------------------
CODE ENDS
END

