* TOOLADDR.S
*
*
* Ermittelt die Startadresse der Toolbox (TRAP #4)
*
* 26.06.90 rr  Neu erstellt.
*

          include   sctb_inc.s     * toolbox include file


TOOLADDR  bsr       sc_check       * check if toolbox installed
          tst.w     d0
          bmi       notool
          move.l    a0,d7          * startadresse in d7

          pea       txt_1          * signup ausgeben
          move.w    #9,-(sp)
          trap      #1
          addq.l    #6,sp

          bsr       hex_long

          pea       txt_2          * zweiten text ausgeben
tool01    move.w    #9,-(sp)
          trap      #1
          addq.l    #6,sp

          move.w    #1,-(sp)       * auf tastendruck warten
          trap      #1
          addq.l    #2,sp

          clr.w     -(sp)          * terminate
          trap      #1

notool    pea       txt_3          * no toolbox available
          bra       tool01

* =============== print D7 as hex longword ===============
*
* reg's D6,D0 destroyed
*

hex_long  move.w    #7,d6          * 8 nibbles to print
hex_l1    rol.l     #4,d7          * rotate left with wraparound

          move.w    #$000f,d0      * mask one nibble
          and.w     d7,d0

          add.w     #'0',d0        * ascii offset
          cmp       #'9',d0        * check range
          ble       hex_09         * if 0..9, jump
          add.w     #'@'-'9',d0    * offset for range A..F
hex_09    move.w    d0,-(sp)       * ascii
          move.w    #2,-(sp)       * print char
          trap      #1
          addq.l    #4,sp

          dbf       d6,hex_l1
          rts


* =============== text area =====================


txt_1     dc.b      27,'E'         * cls
          dc.b      ' TRAP #4 startaddress is ',0
txt_2     dc.b      ' hex.',13,10
          dc.b      ' Press any key to continue...',0
txt_3     dc.b      27,'E'         * cls
          dc.b      ' SuperCharger Toolbox is NOT installed.',13,10,7
          dc.b      ' Press any key to continue...',0

          end


